#!/usr/local/bin/perl
#### Update Ping upsend.pl V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00  

require "libgns.pl";
require 'tbsend.ph';

$AGENT = "upsend.pl";


{
	if ( $FLAG_UPDATEPING ) {
		eval {
			&main();
		};
	};
}
1;

####################################################################

sub main {
	&Setup_KEEPDIR();

	# Update Ping 
	$fin = "$KEEPDIR/$UPDATEPINGLISTNAME";
	if ( open( FIN, "$fin" ) ) {
		while ( $line = <FIN> ) {
			chomp( $line );
			next if ( $line eq "" );
			next if ( $line =~ "^#" );
			$url = $line;

			# HTTPꥯȯ
			$option = "";
			$option .= "User-Agent: $AGENT\n";
			$option .= "Referer: $URLBASENAME$DIGESTNAME\n";
			$option .= "Pragma: no-cache\n";
			$option .= "Content-Type: text/xml\n";
			$diaryurl = "$URLBASENAME$DIGESTNAME";
			$name = &Encode2URL( $DIARY_TITLE, "UTF8" );
			$name =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
			$request = <<request;
<?xml version="1.0" encoding="utf-8"?>
<methodCall>
  <methodName>weblogUpdates.ping</methodName>
  <params>
    <param>
      <value>$name</value>
    </param>
    <param>
      <value>$diaryurl</value>
    </param>
  </params>
</methodCall>
request
			$fout = $TMPDIR . $SLASH . 'upresult.txt';
			$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
			$ret = &SendRequestHTTP( $url, "POST", $fout, $request, $option );
			umask( $umaskback );
 print "SendRequestHTTP( $url, POST, $fout, $request, $option ) = $ret\n";
		}
		close( FIN );
	}

}

########################################################################
### HTTPꥯ 
## SUCCESS = SendRequestHTTP( HREF, METHOD, SAVEAS, REQUEST, OPTION )
#
sub SendRequestHTTP
{
	local( $href ) = shift;
	local( $method ) = shift;
	local( $saveas ) = shift;
	local( $request ) = shift;
	local( $option ) = shift;
	local( $lmdate );
	local( $server );
	local( $port );
	local( $path );
	local( $host );
	local( $sendlen );
	local( $sendstr );
	local( $name, $aliases, $type, $len, $thataddr );
	local( $that );
	local( $proto );
	local( $oldselect );
	local( $gettime );
	local( $readbuf );
	local( $readlength );
	local( $contentlength );
	local( $data );
	local( $isbody ) = 0;
	local( $readimagesize ) = 0;
	local( $contenttype );
	local( $readlines ) = 0;
	local( $readbufsize ) = 1024*4;

	$path = $href;
	if ( $PROXY ne "" ) {
		$server = $PROXY;
		$server =~ s/:.*//;
		$port = $PROXY;
		$port =~ s/.*://;
		$path = $href;
		$host = $href;
		$host =~ s%http://([^/:]+).*$%$1%;
	} else {
		$server = $href;
		$server =~ s%http://([^/:]+).*$%$1%;
		$port = $href;
		$port =~ s%http://[^:/]+:%%;
		$port =~ s%^([^/]*).*$%$1%;
		if ( $port == 0 ) {
			$port = 80;
		}
		$path =~ s%http://[^/]+%%;
		$host = $server;
	}
# print "server = $server\n";
# print "port = $port\n";
# print "path = $path\n";
# print "host = $host\n";

	$sendlen = length( $request );
	$sendstr = "$method $path HTTP/1.1\n";
	$sendstr .= "Host: $host\n";
	$sendstr .= "Content-Length: $sendlen\n";
	$sendstr .= "$option";
	$sendstr .= "\n";
	$sendstr .= $request;
# print "sendstr = $sendstr\n";

	if ( $server =~ /^(\d{1,3})[.](\d{1,3})[.](\d{1,3})[.](\d{1,3})$/ ) {
		$thataddr = pack( 'C4', $1, $2, $3, $4 );
	} else {
		( $name, $aliases, $type, $len, $thataddr ) = gethostbyname( $server );
	}

	$that = pack( $SOCKADDR, $AF_INET, $port, $thataddr );
	( $name, $aliases, $proto ) = getprotobyname( 'tcp' );

	eval {
		$SIG{'ALRM'} = 'timeout';
		sub timeout { die "timeout"; }
		eval {
			alarm( $HTTP_TIMEOUT );
		};
		if ( !socket( S, $AF_INET, $SOCK_STREAM, $proto ) ) {
			die "socket error";
		}
		if ( !connect( S, $that ) ) {
			die "connect error";
		}

		$oldselect = select;
		select ( S );
		$| = 1;
		print S "$sendstr";
		select ( $oldselect );

		$contentlength = 0;
		open( SAVEAS, ">$saveas" );
		print SAVEAS "$sendstr\n";
		while (<S>) {
			s/[\015\012]+//g;
			if ( $_ eq '' ) {
				print SAVEAS "\n";
				last;
			}
			if ( $_ =~ /^Content-Length:[ \t]+(\d+)/i ) {
				$contentlength = $1;
			}
			if ( $_ =~ /^Content-Type:[ \t]+(.*)$/i ) {
				$contenttype = $1;
			}
			print SAVEAS "$_\n";
		}
		close( SAVEAS );
		if ( ($contentlength > 0) && (($method eq "PUT") || ($method eq "GET")) ) {
			binmode( SAVEAS );
			binmode( S );
			while ($contentlength) {
				$readlength = $contentlength;
				$readlength = $readbufsize if ($readlength > $readbufsize);
				$readlength = read( S, $readbuf, $readlength );
				last if ( $readlength == 0 );
				syswrite( SAVEAS, $readbuf, $readlength );
				$contentlength -= $readlength;
			}
			close(SAVEAS);
		} else {
			open( SAVEAS, ">>$saveas" );
			while (<S>) {
				print SAVEAS "$_";
				$readlines++;
			}
			close(SAVEAS);
		}
		close(S);
		eval {
			alarm( 0 );
		};
	};

	if ( $@ ne "" ) {
		close(S);
		close(SAVEAS);

		return (-1) if ( $@ =~ "timeout" );
		return (-2);
	}

	return (0);
}

####################################################################

# [EOF]
